diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/js/tinymce/plugins/media/js/media.js ./wordpress-3.4/wp-includes/js/tinymce/plugins/media/js/media.js
*** ./wordpress-3.3.2/wp-includes/js/tinymce/plugins/media/js/media.js	2011-09-09 15:08:40.000000000 -0500
--- ./wordpress-3.4/wp-includes/js/tinymce/plugins/media/js/media.js	2012-03-14 19:47:06.000000000 -0500
***************
*** 8,13 ****
--- 8,40 ----
  		return document.getElementById(id);
  	}
  
+ 	function clone(obj) {
+ 		var i, len, copy, attr;
+ 
+ 		if (null == obj || "object" != typeof obj)
+ 			return obj;
+ 
+ 		// Handle Array
+ 		if ('length' in obj) {
+ 			copy = [];
+ 
+ 			for (i = 0, len = obj.length; i < len; ++i) {
+ 				copy[i] = clone(obj[i]);
+ 			}
+ 
+ 			return copy;
+ 		}
+ 
+ 		// Handle Object
+ 		copy = {};
+ 		for (attr in obj) {
+ 			if (obj.hasOwnProperty(attr))
+ 				copy[attr] = clone(obj[attr]);
+ 		}
+ 
+ 		return copy;
+ 	}
+ 
  	function getVal(id) {
  		var elm = get(id);
  
***************
*** 21,27 ****
  	}
  
  	function setVal(id, value, name) {
! 		if (typeof(value) != 'undefined') {
  			var elm = get(id);
  
  			if (elm.nodeName == "SELECT")
--- 48,54 ----
  	}
  
  	function setVal(id, value, name) {
! 		if (typeof(value) != 'undefined' && value != null) {
  			var elm = get(id);
  
  			if (elm.nodeName == "SELECT")
***************
*** 39,47 ****
  
  	window.Media = {
  		init : function() {
! 			var html, editor;
  
! 			this.editor = editor = tinyMCEPopup.editor;
  
  			// Setup file browsers and color pickers
  			get('filebrowsercontainer').innerHTML = getBrowserHTML('filebrowser','src','media','media');
--- 66,74 ----
  
  	window.Media = {
  		init : function() {
! 			var html, editor, self = this;
  
! 			self.editor = editor = tinyMCEPopup.editor;
  
  			// Setup file browsers and color pickers
  			get('filebrowsercontainer').innerHTML = getBrowserHTML('filebrowser','src','media','media');
***************
*** 53,59 ****
  			get('audio_altsource2_filebrowser').innerHTML = getBrowserHTML('audio_filebrowser_altsource2','audio_altsource2','media','media');
  			get('video_poster_filebrowser').innerHTML = getBrowserHTML('filebrowser_poster','video_poster','media','image');
  
! 			html = this.getMediaListHTML('medialist', 'src', 'media', 'media');
  			if (html == "")
  				get("linklistrow").style.display = 'none';
  			else
--- 80,86 ----
  			get('audio_altsource2_filebrowser').innerHTML = getBrowserHTML('audio_filebrowser_altsource2','audio_altsource2','media','media');
  			get('video_poster_filebrowser').innerHTML = getBrowserHTML('filebrowser_poster','video_poster','media','image');
  
! 			html = self.getMediaListHTML('medialist', 'src', 'media', 'media');
  			if (html == "")
  				get("linklistrow").style.display = 'none';
  			else
***************
*** 77,85 ****
  			if (isVisible('filebrowser_poster'))
  				get('video_poster').style.width = '220px';
  
! 			this.data = tinyMCEPopup.getWindowArg('data');
! 			this.dataToForm();
! 			this.preview();
  		},
  
  		insert : function() {
--- 104,117 ----
  			if (isVisible('filebrowser_poster'))
  				get('video_poster').style.width = '220px';
  
! 			editor.dom.setOuterHTML(get('media_type'), self.getMediaTypeHTML(editor));
! 
! 			self.setDefaultDialogSettings(editor);
! 			self.data = clone(tinyMCEPopup.getWindowArg('data'));
! 			self.dataToForm();
! 			self.preview();
! 
! 			updateColor('bgcolor_pick', 'bgcolor');
  		},
  
  		insert : function() {
***************
*** 97,103 ****
  		},
  
  		moveStates : function(to_form, field) {
! 			var data = this.data, editor = this.editor, data = this.data,
  				mediaPlugin = editor.plugins.media, ext, src, typeInfo, defaultStates, src;
  
  			defaultStates = {
--- 129,135 ----
  		},
  
  		moveStates : function(to_form, field) {
! 			var data = this.data, editor = this.editor,
  				mediaPlugin = editor.plugins.media, ext, src, typeInfo, defaultStates, src;
  
  			defaultStates = {
***************
*** 144,157 ****
  						formItemName = type == 'global' ? name : type + '_' + name;
  
  						if (type == 'global')
! 							list = data;
! 						else if (type == 'video' || type == 'audio') {
  							list = data.video.attrs;
  
  							if (!list && !to_form)
! 								data.video.attrs = list = {};
  						} else
! 							list = data.params;
  
  						if (list) {
  							if (to_form) {
--- 176,189 ----
  						formItemName = type == 'global' ? name : type + '_' + name;
  
  						if (type == 'global')
! 						list = data;
! 					else if (type == 'video' || type == 'audio') {
  							list = data.video.attrs;
  
  							if (!list && !to_form)
! 							data.video.attrs = list = {};
  						} else
! 						list = data.params;
  
  						if (list) {
  							if (to_form) {
***************
*** 209,214 ****
--- 241,247 ----
  			get('shockwave_options').style.display = 'none';
  			get('windowsmedia_options').style.display = 'none';
  			get('realmedia_options').style.display = 'none';
+ 			get('embeddedaudio_options').style.display = 'none';
  
  			if (get(data.type + '_options'))
  				get(data.type + '_options').style.display = 'block';
***************
*** 222,227 ****
--- 255,261 ----
  			setOptions('realmedia', 'autostart,loop,autogotourl,center,imagestatus,maintainaspect,nojava,prefetch,shuffle,console,controls,numloop,scriptcallbacks');
  			setOptions('video', 'poster,autoplay,loop,muted,preload,controls');
  			setOptions('audio', 'autoplay,loop,preload,controls');
+ 			setOptions('embeddedaudio', 'autoplay,loop,controls');
  			setOptions('global', 'id,name,vspace,hspace,bgcolor,align,width,height');
  
  			if (to_form) {
***************
*** 252,258 ****
  					if (data.type == 'flash') {
  						tinymce.each(editor.getParam('flash_video_player_flashvars', {url : '$url', poster : '$poster'}), function(value, name) {
  							if (value == '$url')
! 								data.params.src = parseQueryParams(data.params.flashvars)[name] || data.params.src;
  						});
  					}
  
--- 286,292 ----
  					if (data.type == 'flash') {
  						tinymce.each(editor.getParam('flash_video_player_flashvars', {url : '$url', poster : '$poster'}), function(value, name) {
  							if (value == '$url')
! 								data.params.src = parseQueryParams(data.params.flashvars)[name] || data.params.src || '';
  						});
  					}
  
***************
*** 260,266 ****
  				}
  			} else {
  				src = getVal("src");
! 	
  				// YouTube
  				if (src.match(/youtube.com(.+)v=([^&]+)/)) {
  					data.width = 425;
--- 294,311 ----
  				}
  			} else {
  				src = getVal("src");
! 
! 				// YouTube *NEW*
! 				if (src.match(/youtu.be\/[a-z1-9.-_]+/)) {
! 					data.width = 425;
! 					data.height = 350;
! 					data.params.frameborder = '0';
! 					data.type = 'iframe';
! 					src = 'http://www.youtube.com/embed/' + src.match(/youtu.be\/([a-z1-9.-_]+)/)[1];
! 					setVal('src', src);
! 					setVal('media_type', data.type);
! 				}
! 
  				// YouTube
  				if (src.match(/youtube.com(.+)v=([^&]+)/)) {
  					data.width = 425;
***************
*** 331,337 ****
  				this.panel = 'source';
  			} else {
  				if (this.panel == 'source') {
! 					this.data = this.editor.plugins.media.htmlToData(getVal('source'));
  					this.dataToForm();
  					this.panel = '';
  				}
--- 376,382 ----
  				this.panel = 'source';
  			} else {
  				if (this.panel == 'source') {
! 					this.data = clone(this.editor.plugins.media.htmlToData(getVal('source')));
  					this.dataToForm();
  					this.panel = '';
  				}
***************
*** 379,384 ****
--- 424,465 ----
  			}
  
  			return "";
+ 		},
+ 
+ 		getMediaTypeHTML : function(editor) {
+ 			function option(media_type, element) {
+ 				if (!editor.schema.getElementRule(element || media_type)) {
+ 					return '';
+ 				}
+ 
+ 				return '<option value="'+media_type+'">'+tinyMCEPopup.editor.translate("media_dlg."+media_type)+'</option>'
+ 			}
+ 
+ 			var html = "";
+ 
+ 			html += '<select id="media_type" name="media_type" onchange="Media.formToData(\'type\');">';
+ 			html += option("video");
+ 			html += option("audio");
+ 			html += option("flash", "object");
+ 			html += option("quicktime", "object");
+ 			html += option("shockwave", "object");
+ 			html += option("windowsmedia", "object");
+ 			html += option("realmedia", "object");
+ 			html += option("iframe");
+ 
+ 			if (editor.getParam('media_embedded_audio', false)) {
+ 				html += option('embeddedaudio', "object");
+ 			}
+ 
+ 			html += '</select>';
+ 			return html;
+ 		},
+ 
+ 		setDefaultDialogSettings : function(editor) {
+ 			var defaultDialogSettings = editor.getParam("media_dialog_defaults", {});
+ 			tinymce.each(defaultDialogSettings, function(v, k) {
+ 				setVal(k, v);
+ 			});
  		}
  	};
  
***************
*** 386,389 ****
  	tinyMCEPopup.onInit.add(function() {
  		Media.init();
  	});
! })();
\ No newline at end of file
--- 467,470 ----
  	tinyMCEPopup.onInit.add(function() {
  		Media.init();
  	});
! })();
